﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;

using MyCompany.MyComponents;
    
namespace ComponentTest
{
    public partial class Form1 : Form
    {
        // Конструктор формы
        public Form1()
        {
            InitializeComponent();
    
            // Заполнение списка планетами
            for (int i = 0; i <= planets1.MaxIndex; i++)
            {
                listPlanets.Items.Add(String.Format(
                    "{0}) {1}", i, planets1[i]));
            }
    
            listPlanets.SelectedIndex = 0;
    
            // Устанавливаем время срабатывания будильника 
            // через 5 сек. после запуска системного таймера
            alarmClock1.AlarmTime = DateTime.Now.AddSeconds(5d);
            alarmClock1.Enabled = true;// Запускаем системный таймер
    
            // Настраиваем второй системный таймер компонента
            alarmClock1.AlarmTimeExt = DateTime.Now.AddSeconds(10d);
            alarmClock1.EnabledExt = true;// Запускаем системный таймер
        }
    
        // Обработчики событий
        private void firstComponent1_Click(object sender, EventArgs e)
        {
            // Контролируем пустой ввод
            if (indexPlanet.Text == String.Empty) return;
    
            int index = Convert.ToInt32(indexPlanet.Text);
    
            // Контролируем максимальный индекс ввода
            index = Math.Min(index, planets1.MaxIndex);
            if (listPlanets.SelectedIndex != index)
                listPlanets.SelectedIndex = index;
            else
                MessageBox.Show(String.Format("Вы выбрали планету {0}", planets1[index]));
        }
    
        private void indexPlanet_KeyPress(object sender, KeyPressEventArgs e)
        {
            // Фильтруем цифры, Backspace, Enter (Delete и стрелки по умолчанию)
            if ((e.KeyChar < Convert.ToChar(Keys.D0) ||
                e.KeyChar > Convert.ToChar(Keys.D9))
                && e.KeyChar != Convert.ToChar(Keys.Back)
                && e.KeyChar != Convert.ToChar(Keys.Enter))
                e.Handled = true;
    
            // Реакция на клавишу Enter
            if (e.KeyChar == Convert.ToChar(Keys.Enter))
                firstComponent1_Click(null, EventArgs.Empty);
        }
    
        bool loadFlag = true; // Локальное поле-флаг
        private void listPlanets_SelectedValueChanged(object sender, EventArgs e)
        {
            int index = listPlanets.SelectedIndex;
            indexPlanet.Text = index.ToString();
            if (loadFlag)
            {
                // При первом запуске не показывать
                loadFlag = false;
                return;
            }
            else
                MessageBox.Show(String.Format("Вы выбрали планету {0}", planets1[index]));
        }

        private void alarmClock1_Alarm(object sender, AlarmClock.AlarmEventArgs e)
        {
            // Если оператор выключения будильника поставить после
            // вызова модального диалогового окна, то генерация
            // событий прекратиться только после закрытия
            // очередного модального окна, поскольку только тогда
            // управление дойдет до этого оператора
            alarmClock1.Enabled = false;// Останавливаем системный таймер
    
            int hour = alarmClock1.CurrentTime.Hour;
            int minute = alarmClock1.CurrentTime.Minute;
            int second = alarmClock1.CurrentTime.Second;
            MessageBox.Show(String.Format("Сработал будильник!!!\n"
                + "Текущее время: {0} ч. {1} м. {2} с.", hour, minute, second),
                "Доцент Снетков В.М.");
        }

        private void alarmClock1_AlarmExt(object sender, AlarmClock.AlarmEventArgs e)
        {
            // Если оператор выключения будильника поставить после
            // вызова модального диалогового окна, то генерация
            // событий прекратиться только после закрытия
            // очередного модального окна, поскольку только тогда
            // управление дойдет до этого оператора
            alarmClock1.EnabledExt = false;// Останавливаем системный таймер
    
            int hour = alarmClock1.CurrentTime.Hour;
            int minute = alarmClock1.CurrentTime.Minute;
            int second = alarmClock1.CurrentTime.Second;
            MessageBox.Show(String.Format("Сработал будильник!!!\n"
                + "Текущее время: {0} ч. {1} м. {2} с.", hour, minute, second),
                "Доцент Снетков В.М.");
    
            // Для генерации сообщения в консольный вывод
            alarmClock1.AlarmExt -= alarmClock1_AlarmExt;
        }
    }
}