﻿using System;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.Collections;
    
namespace MyCompany.MyComponents
{
    //[ToolboxBitmap("1.bmp")]
    public partial class FirstComponent : Control
    {
        public FirstComponent()
        {
            InitializeComponent();

            Init();// Наш метод инициализации
        }

        public FirstComponent(IContainer container)
        {
            container.Add(this);
            InitializeComponent();

            Init();// Наш метод инициализации
        }
    }
}
    
namespace MyCompany.MyComponents
{
    // Определяем перечисление
    public enum EnumType { Zero, One, Two, Three };

    partial class FirstComponent
    {
        // Локальные поля
        int integerProp;
        string stringProp = "По умолчанию";
        char charProp;
        bool boolProp = false;
        EnumType enumProp = EnumType.Zero;
        SomeObject someObject;
    
        // Общедоступные свойства для локальных полей
        public int IntegerProp
        {
            get { return integerProp; }
            set { integerProp = value; }
        }
    
        [DefaultValue("По умолчанию")] // Атрибут значения по умолчанию
        public string StringProp
        {
            get { return stringProp; }
            set { stringProp = value; }
        }
    
        public char CharProp
        {
            get { return charProp; }
            set { charProp = value; }
        }
    
        [DefaultValue(false)] // Атрибут значения по умолчанию
        public bool BoolProp
        {
            get { return boolProp; }
            set { boolProp = value; }
        }
    
        [DefaultValue(EnumType.Zero)] // Атрибут значения по умолчанию
        public EnumType EnumProp
        {
            get { return enumProp; }
            set { enumProp = value; }
        }
    
        // Сложное свойство - объект
        public SomeObject SomeObj
        {
            get { return someObject; }
            set { someObject = value; }
        }
    
        void Init()
        {
            someObject = new SomeObject();
            this.BackColor = System.Drawing.Color.Red;
        }
    }
}
    
namespace MyCompany.MyComponents
{
    // Присоединяем атрибут с контролирующим классом для возможности
    // редактирования свойств объекта в панели Properties оболочки
    [TypeConverter(typeof(SomeObjectConverter))]
    //[TypeConverter(typeof(ExpandableObjectConverter))]
    public class SomeObject : Object
    {
        int prop1;
        string prop2;
    
        // Свойства
        [DefaultValue(2008)] // Атрибут значения по умолчанию
        public int Prop1
        {
            get { return prop1; }
            set { prop1 = value; }
        }
    
        [DefaultValue("Привет")] // Атрибут значения по умолчанию
        public string Prop2
        {
            get { return prop2; }
            set { prop2 = value; }
        }
    
        // Инициализация полей через конструктор
        public SomeObject()
        {
            prop1 = 2008;
            prop2 = "Привет";
        }
    }
}